Index: branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.js
===================================================================
--- branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.js	(revision 4479)
+++ branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.js	(revision 4637)
@@ -391,5 +391,5 @@
         function getBrowserCompatible()
         {
-            return SnifferBrowser.isCompatible('firefox3','firefox4');
+            return SnifferBrowser.isCompatible('firefox3','firefox4','firefox5');
         }
 	
@@ -856,5 +856,5 @@
                 }
 			
-                if( SnifferBrowser.isCompatible('chrome11','ie8','firefox3','firefox4','epiphany2','iceweasel3','safari') )
+                if( SnifferBrowser.isCompatible('chrome11','ie8','firefox3','firefox4','firefox5','epiphany2','iceweasel3','safari') )
                 {	
                     var _idUser	= Base64.decode(getUserCurrent().jid);
@@ -1599,5 +1599,5 @@
                         if( _preferencesIM[0] === 'openWindowJabberit:true' )
                         {
-                            if( SnifferBrowser.isCompatible('chrome11','ie8','firefox3','firefox4','epiphany2','iceweasel3','safari') )
+                            if( SnifferBrowser.isCompatible('chrome11','ie8','firefox3','firefox4','firefox5','epiphany2','iceweasel3','safari') )
                                 TrophyIM.load();
                         }
Index: branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.mini.js
===================================================================
--- branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.mini.js	(revision 4479)
+++ branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.mini.js	(revision 4637)
@@ -84,5 +84,5 @@
 {return document.getElementById(elementId);}
 function getBrowserCompatible()
-{return SnifferBrowser.isCompatible('firefox3','firefox4');}
+{return SnifferBrowser.isCompatible('firefox3','firefox4','firefox5');}
 function getPhotoUser(jid)
 {try
@@ -180,5 +180,5 @@
 {var winRosterDiv={id_window:"window_Roster_im",width:250,height:410,top:50,left:-1500,leftOld:50,draggable:true,visible:"display",resizable:true,zindex:zIndex++,title:"Expresso Messenger - Contatos",closeAction:"hidden",content:""};if(_preferencesIM[0]=="openWindowJabberit:false")
 {winRosterDiv.left=50;winRosterDiv.leftOld=-1500;}
-if(SnifferBrowser.isCompatible('chrome11','ie8','firefox3','firefox4','epiphany2','iceweasel3','safari'))
+if(SnifferBrowser.isCompatible('chrome11','ie8','firefox3','firefox4','firefox5','epiphany2','iceweasel3','safari'))
 {var _idUser=Base64.decode(getUserCurrent().jid);var paramListContact={'idUser':_idUser,'full_name':((fullName.length<25)?fullName:(fullName.substring(0,25)+"...")),'path_jabberit':path_jabberit,'help_expresso':help_expresso,'zIndex_':zIndex++};winRosterDiv.content=Xtools.parse(Xtools.xml("contacts_list"),"contactsList.xsl",paramListContact)}
 else
@@ -322,5 +322,5 @@
 selectEditable=new SelectEditable();addIcon();setTimeout(function()
 {if(_preferencesIM[0]==='openWindowJabberit:true')
-{if(SnifferBrowser.isCompatible('chrome11','ie8','firefox3','firefox4','epiphany2','iceweasel3','safari'))
+{if(SnifferBrowser.isCompatible('chrome11','ie8','firefox3','firefox4','firefox5','epiphany2','iceweasel3','safari'))
 TrophyIM.load();}},1500);autoStatus();configEvents(document,'onmousemove',autoStatus);configEvents(document,'onkeypress',autoStatus);},2000);}}
 loadIM.prototype.adIcon=addIcon;loadIM.prototype.actionButton=actionButton;loadIM.prototype.addContact=addContact;loadIM.prototype.addNewUser=addNewUser;loadIM.prototype.clrAllContacts=clrAllContacts;loadIM.prototype.configEvents=configEvents;loadIM.prototype.createChatRooms=createChatRooms;loadIM.prototype.disabledNotificationNewUsers=disabledNotificationNewUsers;loadIM.prototype.enabledNotificationNewUsers=enabledNotificationNewUsers;loadIM.prototype.getListRooms=getListRooms;loadIM.prototype.getBrowserCompatible=getBrowserCompatible;loadIM.prototype.getPhotoUser=getPhotoUser;loadIM.prototype.getSmiles=getSmiles;loadIM.prototype.getStatusUserIM=getStatusUserIM;loadIM.prototype.getStatusMessage=getStatusMessage;loadIM.prototype.getShowContactsOffline=getShowContactsOffline;loadIM.prototype.getUserCurrent=getUserCurrent;loadIM.prototype.getZIndex=getZindex;loadIM.prototype.groupsHidden=groupsHidden;loadIM.prototype.groupsVisible=groupsVisible;loadIM.prototype.joinRoom=joinRoom;loadIM.prototype.keyPressSearch=keyPressSearch;loadIM.prototype.listRooms=listRooms;loadIM.prototype.loginPage=loginPage;loadIM.prototype.notification=notificationNewMessage;loadIM.prototype.parse=parse;loadIM.prototype.preferences=preferences;loadIM.prototype.searchUser=searchUser