Index: /sandbox/expressoMail1_2/MailArchiver/2.2/expressoMail1_2/js/TreeS.js
===================================================================
--- /sandbox/expressoMail1_2/MailArchiver/2.2/expressoMail1_2/js/TreeS.js	(revision 3761)
+++ /sandbox/expressoMail1_2/MailArchiver/2.2/expressoMail1_2/js/TreeS.js	(revision 4667)
@@ -1,4 +1,4 @@
 /**************************************************************************\
- Início 
+ Inï¿œcio 
 \**************************************************************************/
 
@@ -45,5 +45,5 @@
 							    "</tr>"+
 							    "<tr>"+
-                                                            //Por Bruno Costa(bruno.vieira-costa@serpro.gov.br - Chama o proxy_mensagens para que uma pasta local também possa ser exportada
+                                                            //Por Bruno Costa(bruno.vieira-costa@serpro.gov.br - Chama o proxy_mensagens para que uma pasta local tambï¿œm possa ser exportada
                                                             "<td><input type='button' value='"+get_lang('Export messages')+"' onclick='proxy_mensagens.proxy_export_all_msg()'></td>"+
 							    "</tr>"+
@@ -72,5 +72,5 @@
 			ttree.make_tree(folders,"div_tree","folders_tree","ttree.get_folder(\"root\")","","root",false);
 		else
-			ttree.make_tree(folders,"div_tree","folders_tree","ttree.get_folder(\"local_root\")","","local_root",false);
+                        ttree.make_tree(folders,"div_tree","folders_tree","ttree.get_folder(\"local_root\")","","local_root",false);
 		_this.showWindow(tree);
 
@@ -79,4 +79,5 @@
 	treeS.prototype.get_folder = function(param){
 		this.FOLDER = param;
+                window.alert('TreeS.js com get_folder = ' + param);
 	}
 
@@ -119,6 +120,5 @@
 	
 		this.FOLDER = "";
-		this.arrayW['window_tree'].close();
-	
+		this.arrayW['window_tree'].close();	
 	}
 
@@ -164,6 +164,6 @@
 				}
 				
-				// Foi preciso fazer esse tratamento porque a api (imap_getmailboxes) do PHP retorna uma informação incorreta em algumas ocasiões
-				// a função imap_getmailboxes não retorna o atributo 32 (has_children) quando tem pastas seguindo o seguinte padrão:
+				// Foi preciso fazer esse tratamento porque a api (imap_getmailboxes) do PHP retorna uma informaï¿œï¿œo incorreta em algumas ocasiï¿œes
+				// a funï¿œï¿œo imap_getmailboxes nï¿œo retorna o atributo 32 (has_children) quando tem pastas seguindo o seguinte padrï¿œo:
 				// prefixo
 				//    subPasta1
@@ -171,6 +171,6 @@
 				// prefixo-pasta2  (tudo devido a este underscore aqui)
 				// Caso seja criada pastas dessa forma, a pasta "prefixo", fica com a flag folder_hasChildren como false
-				// sendo assim não aparece o sinal de "mais" na árvore de pastas para poder expandir
-				// Olhar a chamada para a função imap_getmailboxes() dentro do método expressoMail1_2.imap_functions.get_folders_list()
+				// sendo assim nï¿œo aparece o sinal de "mais" na ï¿œrvore de pastas para poder expandir
+				// Olhar a chamada para a funï¿œï¿œo imap_getmailboxes() dentro do mï¿œtodo expressoMail1_2.imap_functions.get_folders_list()
 				// Ticket #1548
 				if(data[i].folder_parent != 'root') {
@@ -185,9 +185,27 @@
 		//Pastas locais
 		if (preferences.use_local_messages == 1) {
-			var n_root_local = new dNode({
+			//MAILARCHIVER
+                        if((ArchiveServices) && (expresso_mail_archive.enabled)){
+                            var n_root_local = new dNode({
 				id: 'local_root',
 				caption: get_lang("local messages"),
 				plusSign: true,
-                                onClick:"ttree.get_folder('local_root')"
+				onClick:"ttree.get_folder('local_root')"
+                            });
+                            folders_tree.add(n_root_local, 'root');
+                            
+                            var drawinginfo = {treeObject: folders_tree, treeName: 'folders_tree'};
+                            expresso_mail_archive.drawdata = drawinginfo;
+                            expresso_mail_archive.drawdata.folderName = 'local_root';
+                            //expresso_mail_archive.getFoldersList("");
+                        }
+                        else{
+                            window.alert('NO local storage...');
+                        }
+                        /*var n_root_local = new dNode({
+				id: 'local_root',
+				caption: get_lang("local messages"),
+				plusSign: true,
+				onClick:"ttree.get_folder('local_root')"
 			});
 			folders_tree.add(n_root_local, 'root');
@@ -195,5 +213,5 @@
 			var local_folders = expresso_local_messages.list_local_folders();
 			for (var i in local_folders) { //Coloca as pastas locais.
-			
+
 				var node_parent = "local_root";
 				var new_caption = local_folders[i][0];
@@ -203,5 +221,5 @@
 					new_caption = local_folders[i][0].substr(final_pos+1);
 				}
-				
+
 				if (local_folders[i][1] > 0) 
 					var nodeLocal = new dNode({
@@ -217,6 +235,22 @@
 					});
 				folders_tree.add(nodeLocal, node_parent);
-			}
-		}
+			}*/
+		}
+/* 		if(folders_tree._folderPr.length > 0 && destination == "div_tree"){
+			var nw_rt = new dNode({id:'proble', caption:'<font style=color:red><b>' + get_lang('Problems') + '</b></font>', plusSign:true});
+			folders_tree.add(nw_rt,'root');
+
+			for(var i=0; i < folders_tree._folderPr.length; i++){
+				var nm_fl = folders_tree._folderPr[i].split(cyrus_delimiter);
+				if( nm_fl[0] == "INBOX")
+					var nm = folders_tree._folderPr[i].substr(6,folders_tree._folderPr[i].length);
+				else
+					var nm = folders_tree._folderPr[i].substr(5,folders_tree._folderPr[i].length);
+				var nw_rm = new dNode({id:folders_tree._folderPr[i], caption:nm, plusSign:false});
+				folders_tree.add(nw_rm,'proble');
+			}
+			folders_tree._folderPr.splice(0,folders_tree._folderPr.length);
+		}
+		*/
 		folders_tree.draw(Element(destination));
 		if(!expresso_offline)