Index: devel/testlink/automation2.0/[FUN02.8] - PesquisarMensagem.xml
===================================================================
--- devel/testlink/automation2.0/[FUN02.8] - PesquisarMensagem.xml	(revision 4627)
+++ devel/testlink/automation2.0/[FUN02.8] - PesquisarMensagem.xml	(revision 4675)
@@ -5,21 +5,26 @@
 	<test name="Pesquisar email normal/importante sem resultado" preserve-order="true">
 		<classes>
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailImportanteTestCase">
-			    <methods>
-			    	<include name="pesquisaMensagemImportanteSemResultado"/>
-			    	<include name="pesquisaMensagemNaoImportanteSemResultado"/>
-			    </methods>
-			</class>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailImportanteSemResultadoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailNaoImportanteSemResultadoTestCase"/>
+		</classes>
+	</test>	
+
+	<test name="Pesquisar email lida/nao lida sem resultado" preserve-order="true">
+		<classes>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailLidaSemResultadoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailNaoLidaSemResultadoTestCase"/>
 		</classes>
 	</test>	
 
 	<test name="Pesquisar email importante com resultado" preserve-order="true">
+		<parameter name="useImportantFlag"  value="Sim"/>
 		<classes>
+			<class name="org.expressolivre.cte.email.MailPreferencesTestCase">
+				<methods>
+					<include name="setImportantFlag"></include>
+				</methods>
+			</class>
 			<class name="org.expressolivre.cte.email.compor.EnviarEmailImportanteTestCase" />
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailImportanteTestCase">
-			    <methods>
-			    	<include name="pesquisaMensagemImportanteComResultado"/>
-			    </methods>
-			</class>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailImportanteComResultadoTestCase"/>
 		</classes>
 	</test>	
@@ -27,58 +32,14 @@
 	<test name="Pesquisar email nÃ£o importante com resultado" preserve-order="true">
 		<classes>
-			<class name="org.expressolivre.cte.email.compor.EnviarEmailTestCase">
-			    <methods>
-			    	<include name="enviarEmail"/>
-			    </methods>
-			</class>
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailImportanteTestCase">
-			    <methods>
-			    	<include name="pesquisaMensagemNaoImportanteComResultado"/>
-			    </methods>
-			</class>
+			<class name="org.expressolivre.cte.email.compor.EnviarEmailTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailNaoImportanteComResultadoTestCase"/>
 		</classes>
 	</test>	
 
-	<test name="Apagar emails recebidos" preserve-order="true">
-		<parameter name="folder" value="lINBOXtree_folders"/>
+	<test name="Pesquisar email lida/nao lida com resultado" preserve-order="true">
 		<classes>
-			<class name="org.expressolivre.cte.email.listar.ApagarTodosEmailsTestCase" />
-		</classes>
-	</test>
- 
-	<test name="Pesquisar email lido/nao lido sem resultado" preserve-order="true">
-		<classes>
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailLidaTestCase">
-			    <methods>
-			    	<include name="pesquisaMensagemLidaSemResultado"/>
-			    	<include name="pesquisaMensagemNaoLidaSemResultado"/>
-			    </methods>
-			</class>
-		</classes>
-	</test>	
-
-	<test name="Pesquisar email nao lido com resultado" preserve-order="true">
-		<classes>
-			<class name="org.expressolivre.cte.email.compor.EnviarEmailTestCase">
-			    <methods>
-			    	<include name="enviarEmail"/>
-			    </methods>
-			</class>
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailLidaTestCase">
-			    <methods>
-			    	<include name="pesquisaMensagemNaoLidaComResultado"/>
-			    </methods>
-			</class>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailNaoLidaComResultadoTestCase"/>
 			<class name="org.expressolivre.cte.email.ler.LerEmailTestCase"/>
-		</classes>
-	</test>	
-
-	<test name="Pesquisar email lido com resultado" preserve-order="true">
-		<classes>
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailLidaTestCase">
-			    <methods>
-			    	<include name="pesquisaMensagemLidaComResultado"/>
-			    </methods>
-			</class>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailLidaComResultadoTestCase"/>
 		</classes>
 	</test>	
@@ -87,18 +48,10 @@
 		<classes>
 			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailParametroInvalidoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailParametroAteDataInvalidoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailParametroDestaDataInvalidoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailParametroNestaDataInvalidoTestCase"/>
 		</classes>
 	</test>	
  
-
-	<test name="Pesquisar email por assunto sem resultado" preserve-order="true">
-		<classes>
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorAssuntoTestCase">
-			    <methods>
-			    	<include name="pesquisaEmailPorAssuntoSemResultado"/>
-			    </methods>
-			</class>
-		</classes>
-	</test>	
-
 	<test name="Apagar emails recebidos" preserve-order="true">
 		<parameter name="folder" value="lINBOXtree_folders"/>
@@ -108,8 +61,16 @@
 	</test>
 
-	<test name="Pesquisar email por assunto" preserve-order="true">
+	<test name="Pesquisar email por assunto sem resultado" preserve-order="true">
+		<classes>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorAssuntoSemResultadoTestCase"/>
+		</classes>
+	</test>	
+
+	<test name="Pesquisar email por assunto com resultado" preserve-order="true">
 		<classes>
 			<class name="org.expressolivre.cte.email.compor.EnviarEmailTestCase"/>
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorAssuntoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorAssuntoComResultadoTestCase"/>
+			<class name="org.expressolivre.cte.email.compor.EnviarEmailAcentoAssuntoTestCase" />
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorAssuntoComAcentoComResultadoTestCase"/>
 		</classes>
 	</test>	
@@ -125,6 +86,8 @@
 		<classes>
 			<class name="org.expressolivre.cte.email.compor.EnviarEmailTestCase"/>
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorDataTestCase"/>
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorIntervaloDataTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorDataComResultadoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorDataSemResultadoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorIntervaloDataComResultadoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorIntervaloDataSemResultadoTestCase"/>
 		</classes>
 	</test>	
@@ -140,5 +103,6 @@
 		<classes>
 			<class name="org.expressolivre.cte.email.compor.EnviarEmailTestCase"/>
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorRemetenteTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorRemetenteComResultadoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorRemetenteSemResultadoTestCase"/>
 		</classes>
 	</test>	
@@ -154,5 +118,6 @@
 		<classes>
 			<class name="org.expressolivre.cte.email.compor.EnviarEmailTestCase"/>
-			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorTextoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorTextoSemResultadoTestCase"/>
+			<class name="org.expressolivre.cte.email.pesquisar.PesquisarEmailPorTextoComResultadoTestCase"/>
 		</classes>
 	</test>	
@@ -205,3 +170,14 @@
 	</test>
 
+	<test name="Voltar flag importante para o padrao" preserve-order="true">
+		<parameter name="useImportantFlag"  value="usar o padrÃ£o"/>
+		<classes>
+			<class name="org.expressolivre.cte.email.MailPreferencesTestCase">
+				<methods>
+					<include name="setImportantFlag"></include>
+				</methods>
+			</class>
+		</classes>
+	</test>
+
 </suite>